;*********************************************************************************************
;*********************************************************************************************
;******************     LIBRAIRIE RENDER    **************************************************
;*********************************************************************************************
;*********************************************************************************************

;*********************************************************************************************
;Rendu en fils de fer
;*********************************************************************************************
draw_lines MACRO
;*********************************************************************************************
;*********************************************************************************************
 btst #0,render
 beq  plus_de_ligne            ;pas de rendu ?

;***  Dessine les lignes
 lea connect,a2                  ;a1:=addr(connect)

draw_next_line:
 cmpi.b #$FF,(a2)
 beq    plus_de_ligne

 moveq.l #0,d7
 move.b (a2)+,d7                 ;d7:=point a relier (pour les lignes)
 asl.l  #2,d7
 add.l adresse_des_coord_2d,d7
 move.l d7,a3                    ;a2:=addr(pt a afficher)

 move.w (a3),d0                  ;d0:=abscisse
 move.w 2(a3),d1                 ;d1:=ordonnees (addresse suivante)

 moveq.l #0,d7
 move.b (a2)+,d7
 asl.l  #2,d7
 add.l adresse_des_coord_2d,d7
 move.l d7,a3

 move.w (a3),d2
 move.w 2(a3),d3                 ;pareil pour (d2;d3)

;***  Dessine la ligne
 bsr bline

 jmp draw_next_line

plus_de_ligne:
 ENDM


;*********************************************************************************************
;*********************************************************************************************
;Rendu avec surface pleine
;*********************************************************************************************
;*********************************************************************************************
draw_surfaces MACRO
;*********************************************************************************************
;*********************************************************************************************
;*********************************************************************************************
 btst #1,render
 beq  plus_de_surface         ;pas de rendu ?

;***  On dessine les textures:
 lea textures,a0
 lea mapping,a1

draw_next_surface:

 cmpi.b #$FF,(a0)
 beq plus_de_surface

 lea polygone,a2
 lea coordonnees_de_mapping,a4

 moveq.w #0,d7
 move.b (a0)+,d7                 ;charge le nbre d'itrations
 move.w d7,(a2)+

point_de_surface_suivant:
 moveq.l #0,d0
 move.b (a0)+,d0                 ;d7:=point a relier (pour les lignes)

 asl.l  #2,d0
 add.l adresse_des_coord_2d,d0
 move.l d0,a3                    ;a2:=addr(pt a afficher)

 move.w (a3),(a2)+               ;transfert l'abscisse
 move.w 2(a3),(a2)+              ;puis l'ordonnees (addresse suivante)

 move.l (a1)+,(a4)+

 subq.b #1,d7
 bne point_de_surface_suivant

;prt  afficher

 movem.l a0-a1,-(a7)
 bsr draw_lined_polygon
 movem.l (a7)+,a0-a1

 jmp draw_next_surface

plus_de_surface:
 ENDM

;*********************************************************************************************
;*********************************************************************************************
;Rendu surfaces couvertes d'une texture
;*********************************************************************************************
draw_textures MACRO
;*********************************************************************************************
;*********************************************************************************************
;*********************************************************************************************
 btst #2,render
 beq  plus_de_texture         ;pas de rendu ?

;***  On dessine les textures:
 lea textures,a0
 lea mapping,a1

draw_next_texture:

 cmpi.b #$FF,(a0)
 beq plus_de_texture

 lea polygone,a2
 lea coordonnees_de_mapping,a4

 move.b (a0)+,d7                 ;charge le nbre d'itrations
 subq.b #3,d7
 bmi draw_next_texture

 move.w #3,(a2)+                 ;triangle donc polygone de 3 cotes

;***
 moveq.l #0,d0
 move.b (a0)+,d0                 ;d7:=point a relier (pour les lignes)
 asl.l  #2,d0
 add.l adresse_des_coord_2d,d0
 move.l d0,a3                    ;a3:=addr(pt a afficher)
 move.l (a3),(a2)+               ;transfert une coordonnee (x et y)
 move.l (a1)+,(a4)+              ;pour les coordonnes map
;***
 moveq.l #0,d0
 move.b (a0)+,d0                 ;d7:=point a relier (pour les lignes)
 asl.l  #2,d0
 add.l adresse_des_coord_2d,d0
 move.l d0,a3                    ;a3:=addr(pt a afficher)
 move.l (a3),(a2)+               ;transfert une coordonnee (x et y)
 move.l (a1)+,(a4)+              ;pour les coordonnes map
;****
 moveq.l #0,d0
 move.b (a0)+,d0                 ;d7:=point a relier (pour les lignes)
 asl.l  #2,d0
 add.l adresse_des_coord_2d,d0
 move.l d0,a3                    ;a3:=addr(pt a afficher)
 move.l (a3),(a2)                ;transfert une coordonnee (x et y)
 move.l (a1)+,(a4)               ;pour les coordonnes map
;***

;** Decomposition du polygone en triangle
texture_triangle_suivante:

 movem.l a0-a4/d7,-(a7)
 bsr draw_textured_polygon
 movem.l (a7)+,a0-a4/d7

 subq.b #1,d7
 bmi draw_next_texture

 move.l (a2),-4(a2)
 move.l (a4),-4(a4)

 moveq.l #0,d0
 move.b (a0)+,d0                 ;d7:=point a relier (pour les lignes)
 asl.l  #2,d0
 add.l adresse_des_coord_2d,d0
 move.l d0,a3                    ;a3:=addr(pt a afficher)
 move.l (a3),(a2)               ;transfert une coordonnee (x et y)

 move.l (a1)+,(a4)              ;pour les coordonnes map

 jmp texture_triangle_suivante

plus_de_texture:
 ENDM
